package com.huiju.estateagents.channel.sysChannel.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huiju.estateagents.channel.sysChannel.entity.TaChannelProxy;
import com.huiju.estateagents.channel.sysChannel.mapper.TaChannelProxyMapper;
import com.huiju.estateagents.channel.sysChannel.service.ITaChannelProxyService;
import com.huiju.estateagents.entity.TaChannelAppRelation;
import com.huiju.estateagents.mapper.TaChannelAppRelationMapper;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class TaChannelProxyServiceImpl extends ServiceImpl<TaChannelProxyMapper, TaChannelProxy>  implements ITaChannelProxyService {
    @Autowired
    private TaChannelProxyMapper taChannelProxyMapper;

    @Autowired
    private TaChannelAppRelationMapper taChannelAppRelationMapper;

    @Override
    public IPage<TaChannelProxy> getChannelList(IPage page) {
        IPage<TaChannelProxy> taChannelProxyIPage = taChannelProxyMapper.getChannelList(page);
        if (CollectionUtils.isNotEmpty(taChannelProxyIPage.getRecords())){
            taChannelProxyIPage.getRecords().forEach(e->{
                QueryWrapper<TaChannelAppRelation> taChannelAppRelationQueryWrapper = new QueryWrapper<>();
                taChannelAppRelationQueryWrapper.eq("channel_id", e.getChannelId());
                taChannelAppRelationQueryWrapper.groupBy("channel_id");
                e.setAppCurrentNum(taChannelAppRelationMapper.selectCount(taChannelAppRelationQueryWrapper));
            });
            taChannelProxyIPage.setRecords(taChannelProxyIPage.getRecords());
        }
        return taChannelProxyIPage;
    }
}
